package com.liang.service.impl;

import com.liang.entity.BaseTitle;
import com.liang.dao.BaseTitleDao;
import com.liang.service.BaseTitleService;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * (BaseTitle)表服务实现类
 *
 * @author makejava
 * @since 2023-03-03 21:59:50
 */
@Service("baseTitleService")
public class BaseTitleServiceImpl implements BaseTitleService {
    @Resource
    private BaseTitleDao baseTitleDao;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BaseTitle queryById(Object id) {
        return this.baseTitleDao.queryById(id);
    }

    /**
     * 分页查询
     *
     * @param baseTitle   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<BaseTitle> queryByPage(BaseTitle baseTitle, PageRequest pageRequest) {
        long total = this.baseTitleDao.count(baseTitle);
        return new PageImpl<>(this.baseTitleDao.queryAllByLimit(baseTitle, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param baseTitle 实例对象
     * @return 实例对象
     */
    @Override
    public BaseTitle insert(BaseTitle baseTitle) {
        this.baseTitleDao.insert(baseTitle);
        return baseTitle;
    }

    /**
     * 修改数据
     *
     * @param baseTitle 实例对象
     * @return 实例对象
     */
    @Override
    public BaseTitle update(BaseTitle baseTitle) {
        this.baseTitleDao.update(baseTitle);
        return this.queryById(baseTitle.getId());
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Object id) {
        return this.baseTitleDao.deleteById(id) > 0;
    }

    @Override
    public List<BaseTitle> queryAll() {
        return this.baseTitleDao.queryAll();
    }

    @Override
    public List<Map<String, String>> getTitleList() {
        return this.baseTitleDao.getTitleList();
    }
}
